#ifndef __GAME_OBJECT_LUA_H__
#define __GAME_OBJECT_LUA_H__

#include "s3e.h"
#include "LuaWrapper.h"
#include "GameObject.h"

namespace SC {

	class GameObjectLua: public GameObject {
	public:
		GameObjectLua();
		virtual ~GameObjectLua();

		virtual void update(uint64 delta);

		// Graphic Asset State
		static int GOLua_SetState(lua_State * L);
		static int GOLua_GetState(lua_State * L);

		// Some physics
		static int GOLua_GetLinearVelocity(lua_State * L);
		static int GOLua_SetLinearVelocity(lua_State * L);
		static int GOLua_ApplyForce(lua_State * L);

		// Position
		static int GOLua_GetPosition(lua_State * L);
		static int GOLua_SetPosition(lua_State * L);

	private:
		char mLuaObjName[100];

	};

	static const struct luaL_reg GameObjectLib[] = {
		{"getState", GameObjectLua::GOLua_GetState},
		{"setState", GameObjectLua::GOLua_SetState},
		{"getLinearVelocity", GameObjectLua::GOLua_GetLinearVelocity},
		{"setLinearVelocity", GameObjectLua::GOLua_SetLinearVelocity},
		{"getPosition", GameObjectLua::GOLua_GetPosition},
		{"setPosition", GameObjectLua::GOLua_SetPosition},
		{"applyForce", GameObjectLua::GOLua_ApplyForce},
		{NULL, NULL}
	};

} // namespace SC

#endif // __GAME_OBJECT_LUA_H__
