#include "s3e.h"
#include "LuaWrapper.h"

extern "C" {
#include "lualib.h"
#include "lauxlib.h"
#include "lua.h"
}

namespace SC {

	LuaWrapper * LuaWrapper::instance = NULL;

	LuaWrapper::LuaWrapper()
	{
		mLua = lua_open();
		luaopen_base(mLua);
		luaopen_table(mLua);
		luaopen_string(mLua);
		luaopen_math(mLua);

		int s = luaL_loadfile(mLua, "lua/RobotTest.lua");
		if ( s==0 ) {
			// execute Lua program
			s = lua_pcall(mLua, 0, LUA_MULTRET, 0);
		}
	}

	LuaWrapper::~LuaWrapper()
	{
		lua_close(mLua);
	}


} // namespace SC
