#ifndef __LUA_WRAPPER_H__
#define __LUA_WRAPPER_H__

#include <string.h>
#include "IwDebug.h"

extern "C" {
#include "lualib.h"
#include "lauxlib.h"
#include "lua.h"
}


namespace SC {

	class LuaWrapper {
	public:
		LuaWrapper();
		virtual ~LuaWrapper();

		static LuaWrapper * GetPtr(void)
		{
			if (instance == NULL) {
				instance = new LuaWrapper();
			}

			return (instance);
		}

		lua_State *getLuaState(void) {return mLua;}

	private:
		// Singleton
		static LuaWrapper * instance;

		lua_State *mLua;
	};


} // namespace SC

#endif // __LUA_WRAPPER_H__